library angular2.src.change_detection.exceptions;

import "proto_record.dart" show ProtoRecord;
import "package:angular2/src/facade/lang.dart" show BaseException;

class ExpressionChangedAfterItHasBeenChecked extends BaseException {
  String message;
  ExpressionChangedAfterItHasBeenChecked(ProtoRecord proto, dynamic change)
      : super() {
    /* super call moved to initializer */;
    this.message =
        '''Expression \'${ proto . expressionAsString}\' has changed after it was checked. ''' +
            '''Previous value: \'${ change . previousValue}\'. Current value: \'${ change . currentValue}\'''';
  }
  String toString() {
    return this.message;
  }
}
class ChangeDetectionError extends BaseException {
  dynamic originalException;
  String message;
  String location;
  ChangeDetectionError(ProtoRecord proto, this.originalException) : super() {
    /* super call moved to initializer */;
    this.location = proto.expressionAsString;
    this.message = '''${ this . originalException} in [${ this . location}]''';
  }
  String toString() {
    return this.message;
  }
}
class DehydratedException extends BaseException {
  DehydratedException()
      : super("Attempt to detect changes on a dehydrated detector.") {
    /* super call moved to initializer */;
  }
}
