library angular2.src.change_detection.pipes.json_pipe;

import "package:angular2/src/facade/lang.dart" show isBlank, isPresent, Json;
import "pipe.dart" show Pipe, BasePipe, PipeFactory;

/**
 * Implements json transforms to any object.
 *
 * # Example
 *
 * In this example we transform the user object to json.
 *
 *  ```
 * @Component({
 *   selector: "user-cmp"
 * })
 * @View({
 *   template: "User: {{ user | json }}"
 * })
 * class Username {
 *  user:Object
 *  constructor() {
 *    this.user = { name: "PatrickJS" };
 *  }
 * }
 *
 * ```
 *
 * @exportedAs angular2/pipes
 */
class JsonPipe extends BasePipe {
  String transform(value) {
    return Json.stringify(value);
  }
  Pipe create(cdRef) {
    return this;
  }
}
