library angular2.src.core.compiler.element_ref;

import "package:angular2/src/facade/lang.dart" show BaseException;
import "view_ref.dart" show ViewRef;
import "package:angular2/src/render/api.dart"
    show RenderViewRef, RenderElementRef, Renderer;

/**
 * @exportedAs angular2/view
 */
class ElementRef implements RenderElementRef {
  ViewRef parentView;
  num boundElementIndex;
  Renderer _renderer;
  ElementRef(this.parentView, this.boundElementIndex, this._renderer) {}
  RenderViewRef get renderView {
    return this.parentView.render;
  }
  // TODO(tbosch): remove this once Typescript supports declaring interfaces

  // that contain getters
  set renderView(RenderViewRef viewRef) {
    throw new BaseException("Abstract setter");
  }
  /**
   * Exposes the underlying native element.
   * Attention: This won't work in a webworker scenario!
   */
  dynamic get nativeElement {
    return this._renderer.getNativeElementSync(this);
  }
}
